unit UPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, AG,
  StdCtrls, Mask, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    rgSelecao: TRadioGroup;
    rgOtimizacao: TRadioGroup;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    eCross: TMaskEdit;
    eMut: TMaskEdit;
    eTamPop: TMaskEdit;
    eSem: TMaskEdit;
    eTamCrom: TMaskEdit;
    Label5: TLabel;
    Label8: TLabel;
    eIndEli: TMaskEdit;
    eNumCross: TMaskEdit;
    Label9: TLabel;
    Label6: TLabel;
    eArqSaida: TEdit;
    Label7: TLabel;
    eNumGer: TMaskEdit;
    procedure Button1Click(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

function funcaoExemplo(cromossomo: tCromossomo): real;
var
soma,i:longInt;
begin
soma:=0;
for i:=1 to strtoint(form1.eTamCrom.text) do
    if cromossomo[i] then inc (soma);
result:=soma;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
numGer,g:integer;
ag: tAlgGen;
begin
ag:=tAlgGen.create(eArqSaida.Text,funcaoExemplo);
ag.tamanhoCromossomo:=strtoint(eTamCrom.text);
ag.tamanhoPopulacao:=strtoint(eTamPop.text);
ag.probabilidadeCrossover:=strtofloat('0,'+eCross.text);
ag.probabilidadeMutacao:=strtofloat('0,'+eMut.text);
ag.numeroPontosCrossover:=strtoint(eNumCross.text);
ag.numeroElitismo:=strtoint(eIndEli.Text);
ag.semente:=strtofloat('0,'+eSem.Text);
if rgSelecao.itemIndex=0 then ag.tipoDaSelecao:=rank
else ag.tipoDaSelecao:=roleta;
if rgOtimizacao.itemIndex=0 then ag.tipoDeOtimizacao:=maximizacao
else ag.tipoDeOtimizacao:=minimizacao;
numGer:=strtoint(eNumGer.Text);

g:=0;
repeat
    ag.geracao;
    inc(g);
    until (g > numGer);
ag.destroy;
Application.MessageBox('Os resultados foram salvos.' ,'Programa Teste AG - Aviso',0+mb_IconInformation);
end;

end.
